#ifndef __IGC_LOG_QUERY_H__
#define __IGC_LOG_QUERY_H__
//--------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved.
//
// Class: IGClogQuery
//
// Description:
//
// Class interface definition.
//
// This file is automatically generated.
// DO NOT EDIT.
//
// Author: codegen2
// Date:   Thursday, October 15th, 2009 @ 04:04:10 PM
// Revision: $Revision: 1.4 $
//
// Last Edit Date: $Date: 2009-10-21 18:42:31 $
// Source: $Source: /home/cvs/cvsroot/IGC/IGClogQuery.h,v $
//--------------------------------------------------------------------------

#include <time.h>
#include <IGC/IGCminimumInclude.h>
// Predeclared Classes
class IGClogQueryResult;


#ifndef __IGC_LOG_QUERY_HANDLE_H__
#define __IGC_LOG_QUERY_HANDLE_H__
typedef void* IGClogQueryHandle;
#endif


/**
 *  This class is used to represent an Iguana log query. 
 * 
 */
class IGClogQuery
{
public:
   /** Constructor */
   IGClogQuery();
   IGClogQuery(const IGClogQuery& Orig);
   IGClogQuery(IGClogQueryHandle Handle);
   
   /** Destructor */
   virtual ~IGClogQuery();
   
   /** Assignment operator */
   IGClogQuery& operator=(const IGClogQuery& Orig);
   
   /** This method is part of the internal implementation of this class and should not be called. */
   IGClogQueryHandle GetHandle() const { return Handle; }
   
   
   /**
    *  Specifies the hostname or IP address of the Iguana server. 
    * 
    * See also the IGClogQuery#SetHost method.
    * 
    */
   const char* Host() const;
   
   
   /**
    * Set method for Host.
    * 
    * See IGClogQuery#Host.
    * 
    * @param Value Value to set Host to.
    */
   void SetHost(const char* Value);
   
   
   /**
    *  Specifies the port number which is used to access the Iguana server's HTTP 
    * interface. 
    * 
    * See also the IGClogQuery#SetPort method.
    * 
    */
   IGCint32 Port() const;
   
   
   /**
    * Set method for Port.
    * 
    * See IGClogQuery#Port.
    * 
    * @param Value Value to set Port to.
    */
   void SetPort(IGCint32 Value);
   
   
   /**
    *  Specifies the username which should be used to authenticate with the Iguana 
    * server. 
    * 
    * See also the IGClogQuery#SetUsername method.
    * 
    */
   const char* Username() const;
   
   
   /**
    * Set method for Username.
    * 
    * See IGClogQuery#Username.
    * 
    * @param Value Value to set Username to.
    */
   void SetUsername(const char* Value);
   
   
   /**
    *  Specifies the password which should be used to authenticate with the Iguana 
    * server. 
    * 
    * See also the IGClogQuery#SetPassword method.
    * 
    */
   const char* Password() const;
   
   
   /**
    * Set method for Password.
    * 
    * See IGClogQuery#Password.
    * 
    * @param Value Value to set Password to.
    */
   void SetPassword(const char* Value);
   
   
   /**
    *  Specifies the filter string to be used in the search. 
    * 
    * See also the IGClogQuery#SetFilter method.
    * 
    */
   const char* Filter() const;
   
   
   /**
    * Set method for Filter.
    * 
    * See IGClogQuery#Filter.
    * 
    * @param Value Value to set Filter to.
    */
   void SetFilter(const char* Value);
   
   
   /**
    *  Specifies the channel name to retrieve logs for. 
    * 
    *  If no channel name is specified, all channels are included. 
    * 
    * See also the IGClogQuery#SetChannelName method.
    * 
    */
   const char* ChannelName() const;
   
   
   /**
    * Set method for ChannelName.
    * 
    * See IGClogQuery#ChannelName.
    * 
    * @param Value Value to set ChannelName to.
    */
   void SetChannelName(const char* Value);
   
   
   /**
    *  Specifies the message log ID to retrieve logs for. 
    * 
    * See also the IGClogQuery#SetMessageLogId method.
    * 
    */
   const char* MessageLogId() const;
   
   
   /**
    * Set method for MessageLogId.
    * 
    * See IGClogQuery#MessageLogId.
    * 
    * @param Value Value to set MessageLogId to.
    */
   void SetMessageLogId(const char* Value);
   
   
   /**
    *  Indicates that actual Message logs should be included. 
    * 
    * See also the IGClogQuery#SetIncludeMessageMessages method.
    * 
    */
   IGCboolean IncludeMessageMessages() const;
   
   
   /**
    * Set method for IncludeMessageMessages.
    * 
    * See IGClogQuery#IncludeMessageMessages.
    * 
    * @param Value Value to set IncludeMessageMessages to.
    */
   void SetIncludeMessageMessages(IGCboolean Value);
   
   
   /**
    *  Indicates that ACKnowledgement messages should be included. 
    * 
    * See also the IGClogQuery#SetIncludeAckMessages method.
    * 
    */
   IGCboolean IncludeAckMessages() const;
   
   
   /**
    * Set method for IncludeAckMessages.
    * 
    * See IGClogQuery#IncludeAckMessages.
    * 
    * @param Value Value to set IncludeAckMessages to.
    */
   void SetIncludeAckMessages(IGCboolean Value);
   
   
   /**
    *  Indicates that success messages should be included. 
    * 
    * See also the IGClogQuery#SetIncludeSuccessMessages method.
    * 
    */
   IGCboolean IncludeSuccessMessages() const;
   
   
   /**
    * Set method for IncludeSuccessMessages.
    * 
    * See IGClogQuery#IncludeSuccessMessages.
    * 
    * @param Value Value to set IncludeSuccessMessages to.
    */
   void SetIncludeSuccessMessages(IGCboolean Value);
   
   
   /**
    *  Indicates that warning messages should be included. 
    * 
    * See also the IGClogQuery#SetIncludeWarningMessages method.
    * 
    */
   IGCboolean IncludeWarningMessages() const;
   
   
   /**
    * Set method for IncludeWarningMessages.
    * 
    * See IGClogQuery#IncludeWarningMessages.
    * 
    * @param Value Value to set IncludeWarningMessages to.
    */
   void SetIncludeWarningMessages(IGCboolean Value);
   
   
   /**
    *  Indicates that error messages should be included. 
    * 
    * See also the IGClogQuery#SetIncludeErrorMessages method.
    * 
    */
   IGCboolean IncludeErrorMessages() const;
   
   
   /**
    * Set method for IncludeErrorMessages.
    * 
    * See IGClogQuery#IncludeErrorMessages.
    * 
    * @param Value Value to set IncludeErrorMessages to.
    */
   void SetIncludeErrorMessages(IGCboolean Value);
   
   
   /**
    *  Indicates that information messages should be included. 
    * 
    * See also the IGClogQuery#SetIncludeInfoMessages method.
    * 
    */
   IGCboolean IncludeInfoMessages() const;
   
   
   /**
    * Set method for IncludeInfoMessages.
    * 
    * See IGClogQuery#IncludeInfoMessages.
    * 
    * @param Value Value to set IncludeInfoMessages to.
    */
   void SetIncludeInfoMessages(IGCboolean Value);
   
   
   /**
    *  Indicates that debug messages should be included. 
    * 
    * See also the IGClogQuery#SetIncludeDebugMessages method.
    * 
    */
   IGCboolean IncludeDebugMessages() const;
   
   
   /**
    * Set method for IncludeDebugMessages.
    * 
    * See IGClogQuery#IncludeDebugMessages.
    * 
    * @param Value Value to set IncludeDebugMessages to.
    */
   void SetIncludeDebugMessages(IGCboolean Value);
   
   
   /**
    *  Indicates that deleted messages should be included. 
    * 
    * See also the IGClogQuery#SetIncludeDeleted method.
    * 
    */
   IGCboolean IncludeDeleted() const;
   
   
   /**
    * Set method for IncludeDeleted.
    * 
    * See IGClogQuery#IncludeDeleted.
    * 
    * @param Value Value to set IncludeDeleted to.
    */
   void SetIncludeDeleted(IGCboolean Value);
   
   
   /**
    *  Indicates that non-deleted messages should be included. 
    * 
    * See also the IGClogQuery#SetIncludeNonDeleted method.
    * 
    */
   IGCboolean IncludeNonDeleted() const;
   
   
   /**
    * Set method for IncludeNonDeleted.
    * 
    * See IGClogQuery#IncludeNonDeleted.
    * 
    * @param Value Value to set IncludeNonDeleted to.
    */
   void SetIncludeNonDeleted(IGCboolean Value);
   
   
   /**
    *  Indicates that messages associated with the source channel should be included. 
    * 
    * See also the IGClogQuery#SetIncludeSourceLogs method.
    * 
    */
   IGCboolean IncludeSourceLogs() const;
   
   
   /**
    * Set method for IncludeSourceLogs.
    * 
    * See IGClogQuery#IncludeSourceLogs.
    * 
    * @param Value Value to set IncludeSourceLogs to.
    */
   void SetIncludeSourceLogs(IGCboolean Value);
   
   
   /**
    *  Specifies the starting timestamp for the search. 
    * 
    * See also the IGClogQuery#SetAfter method.
    * 
    */
   time_t After() const;
   
   
   /**
    * Set method for After.
    * 
    * See IGClogQuery#After.
    * 
    * @param Value Value to set After to.
    */
   void SetAfter(time_t Value);
   
   
   /**
    *  Specifies the ending timestamp for the search. 
    * 
    * See also the IGClogQuery#SetBefore method.
    * 
    */
   time_t Before() const;
   
   
   /**
    * Set method for Before.
    * 
    * See IGClogQuery#Before.
    * 
    * @param Value Value to set Before to.
    */
   void SetBefore(time_t Value);
   
   
   /**
    *  Perform a query on the configured Iguana server. 
    * 
    *  Note that this method will block while the query is performed. 
    * 
    */
   IGClogQueryResult Execute();
   
   
private:
   IGClogQueryHandle Handle;
};

#endif // end of defensive include
